package company;


import java.util.List;
import name.panitz.crempel.util.Maybe;

public class Dept implements DeptVisitable{
  private final Name theName;
  private final Employee theEmployee;
  private final List<Choice_PU_DU> theList_Choice_PU_DU_;

  public Dept(Name theName,Employee theEmployee,List<Choice_PU_DU> theList_Choice_PU_DU_){
    this.theName = theName;
    this.theEmployee = theEmployee;
    this.theList_Choice_PU_DU_ = theList_Choice_PU_DU_;
  }

  public Name getTheName(){return theName;}
  public Employee getTheEmployee(){return theEmployee;}
  public List<Choice_PU_DU> getTheList_Choice_PU_DU_(){return theList_Choice_PU_DU_;}
  public <_b> _b visit(DeptVisitor<_b> visitor){
    return visitor.eval(this);
  }
  public String toString(){
    return "Dept("+theName+","+theEmployee+","+theList_Choice_PU_DU_+")";
  }
  public boolean equals(Object other){
    if (!(other instanceof Dept)) return false;
    final Dept o= (Dept) other;
    return true  && theName.equals(o.theName)&& theEmployee.equals(o.theEmployee)&& theList_Choice_PU_DU_.equals(o.theList_Choice_PU_DU_);
  }
}
