package company;


import java.util.List;
import name.panitz.crempel.util.Maybe;

public class Address implements AddressVisitable{
  private final String pcdata;

  public Address(String pcdata){
    this.pcdata = pcdata;
  }

  public String getPcdata(){return pcdata;}
  public <_b> _b visit(AddressVisitor<_b> visitor){
    return visitor.eval(this);
  }
  public String toString(){
    return "Address("+pcdata+")";
  }
  public boolean equals(Object other){
    if (!(other instanceof Address)) return false;
    final Address o= (Address) other;
    return true  && pcdata.equals(o.pcdata);
  }
}
