package company;


import java.util.List;
import name.panitz.crempel.util.Maybe;

public class Company implements CompanyVisitable{
  private final List<Dept> xs;

  public Company(List<Dept> xs){
    this.xs = xs;
  }

  public List<Dept> getXs(){return xs;}
  public <_b> _b visit(CompanyVisitor<_b> visitor){
    return visitor.eval(this);
  }
  public String toString(){
    return "Company("+xs+")";
  }
  public boolean equals(Object other){
    if (!(other instanceof Company)) return false;
    final Company o= (Company) other;
    return true  && xs.equals(o.xs);
  }
}
