package company;


import java.util.List;
import name.panitz.crempel.util.Maybe;

public class Employee implements EmployeeVisitable{
  private final Person thePerson;
  private final Salary theSalary;

  public Employee(Person thePerson,Salary theSalary){
    this.thePerson = thePerson;
    this.theSalary = theSalary;
  }

  public Person getThePerson(){return thePerson;}
  public Salary getTheSalary(){return theSalary;}
  public <_b> _b visit(EmployeeVisitor<_b> visitor){
    return visitor.eval(this);
  }
  public String toString(){
    return "Employee("+thePerson+","+theSalary+")";
  }
  public boolean equals(Object other){
    if (!(other instanceof Employee)) return false;
    final Employee o= (Employee) other;
    return true  && thePerson.equals(o.thePerson)&& theSalary.equals(o.theSalary);
  }
}
