package company;


import java.util.List;
import name.panitz.crempel.util.Maybe;

public class Person implements PersonVisitable{
  private final Name theName;
  private final Address theAddress;

  public Person(Name theName,Address theAddress){
    this.theName = theName;
    this.theAddress = theAddress;
  }

  public Name getTheName(){return theName;}
  public Address getTheAddress(){return theAddress;}
  public <_b> _b visit(PersonVisitor<_b> visitor){
    return visitor.eval(this);
  }
  public String toString(){
    return "Person("+theName+","+theAddress+")";
  }
  public boolean equals(Object other){
    if (!(other instanceof Person)) return false;
    final Person o= (Person) other;
    return true  && theName.equals(o.theName)&& theAddress.equals(o.theAddress);
  }
}
